package com.hai.dao;

import com.hai.entity.HighTyAgent;
import com.hai.entity.HighTyAgentExample;
import java.util.List;
import org.apache.ibatis.annotations.Delete;
import org.apache.ibatis.annotations.DeleteProvider;
import org.apache.ibatis.annotations.Insert;
import org.apache.ibatis.annotations.InsertProvider;
import org.apache.ibatis.annotations.Options;
import org.apache.ibatis.annotations.Param;
import org.apache.ibatis.annotations.Result;
import org.apache.ibatis.annotations.Results;
import org.apache.ibatis.annotations.Select;
import org.apache.ibatis.annotations.SelectProvider;
import org.apache.ibatis.annotations.Update;
import org.apache.ibatis.annotations.UpdateProvider;
import org.apache.ibatis.type.JdbcType;
import org.springframework.stereotype.Repository;

/**
 * 
 * 代码由工具生成,请勿修改!!!
 * 如果需要扩展请在其父类进行扩展
 * 
 **/
@Repository
public interface HighTyAgentMapper extends HighTyAgentMapperExt {
    @SelectProvider(type=HighTyAgentSqlProvider.class, method="countByExample")
    long countByExample(HighTyAgentExample example);

    @DeleteProvider(type=HighTyAgentSqlProvider.class, method="deleteByExample")
    int deleteByExample(HighTyAgentExample example);

    @Delete({
        "delete from high_ty_agent",
        "where id = #{id,jdbcType=BIGINT}"
    })
    int deleteByPrimaryKey(Long id);

    @Insert({
        "insert into high_ty_agent (org_id, agent_key, ",
        "agent_name, agent_address, ",
        "agent_user, agent_phone, ",
        "`status`, create_time, ",
        "update_time, ext_1, ",
        "ext_2, ext_3)",
        "values (#{orgId,jdbcType=BIGINT}, #{agentKey,jdbcType=VARCHAR}, ",
        "#{agentName,jdbcType=VARCHAR}, #{agentAddress,jdbcType=VARCHAR}, ",
        "#{agentUser,jdbcType=VARCHAR}, #{agentPhone,jdbcType=VARCHAR}, ",
        "#{status,jdbcType=INTEGER}, #{createTime,jdbcType=TIMESTAMP}, ",
        "#{updateTime,jdbcType=TIMESTAMP}, #{ext1,jdbcType=VARCHAR}, ",
        "#{ext2,jdbcType=VARCHAR}, #{ext3,jdbcType=VARCHAR})"
    })
    @Options(useGeneratedKeys=true,keyProperty="id")
    int insert(HighTyAgent record);

    @InsertProvider(type=HighTyAgentSqlProvider.class, method="insertSelective")
    @Options(useGeneratedKeys=true,keyProperty="id")
    int insertSelective(HighTyAgent record);

    @SelectProvider(type=HighTyAgentSqlProvider.class, method="selectByExample")
    @Results({
        @Result(column="id", property="id", jdbcType=JdbcType.BIGINT, id=true),
        @Result(column="org_id", property="orgId", jdbcType=JdbcType.BIGINT),
        @Result(column="agent_key", property="agentKey", jdbcType=JdbcType.VARCHAR),
        @Result(column="agent_name", property="agentName", jdbcType=JdbcType.VARCHAR),
        @Result(column="agent_address", property="agentAddress", jdbcType=JdbcType.VARCHAR),
        @Result(column="agent_user", property="agentUser", jdbcType=JdbcType.VARCHAR),
        @Result(column="agent_phone", property="agentPhone", jdbcType=JdbcType.VARCHAR),
        @Result(column="status", property="status", jdbcType=JdbcType.INTEGER),
        @Result(column="create_time", property="createTime", jdbcType=JdbcType.TIMESTAMP),
        @Result(column="update_time", property="updateTime", jdbcType=JdbcType.TIMESTAMP),
        @Result(column="ext_1", property="ext1", jdbcType=JdbcType.VARCHAR),
        @Result(column="ext_2", property="ext2", jdbcType=JdbcType.VARCHAR),
        @Result(column="ext_3", property="ext3", jdbcType=JdbcType.VARCHAR)
    })
    List<HighTyAgent> selectByExample(HighTyAgentExample example);

    @Select({
        "select",
        "id, org_id, agent_key, agent_name, agent_address, agent_user, agent_phone, `status`, ",
        "create_time, update_time, ext_1, ext_2, ext_3",
        "from high_ty_agent",
        "where id = #{id,jdbcType=BIGINT}"
    })
    @Results({
        @Result(column="id", property="id", jdbcType=JdbcType.BIGINT, id=true),
        @Result(column="org_id", property="orgId", jdbcType=JdbcType.BIGINT),
        @Result(column="agent_key", property="agentKey", jdbcType=JdbcType.VARCHAR),
        @Result(column="agent_name", property="agentName", jdbcType=JdbcType.VARCHAR),
        @Result(column="agent_address", property="agentAddress", jdbcType=JdbcType.VARCHAR),
        @Result(column="agent_user", property="agentUser", jdbcType=JdbcType.VARCHAR),
        @Result(column="agent_phone", property="agentPhone", jdbcType=JdbcType.VARCHAR),
        @Result(column="status", property="status", jdbcType=JdbcType.INTEGER),
        @Result(column="create_time", property="createTime", jdbcType=JdbcType.TIMESTAMP),
        @Result(column="update_time", property="updateTime", jdbcType=JdbcType.TIMESTAMP),
        @Result(column="ext_1", property="ext1", jdbcType=JdbcType.VARCHAR),
        @Result(column="ext_2", property="ext2", jdbcType=JdbcType.VARCHAR),
        @Result(column="ext_3", property="ext3", jdbcType=JdbcType.VARCHAR)
    })
    HighTyAgent selectByPrimaryKey(Long id);

    @UpdateProvider(type=HighTyAgentSqlProvider.class, method="updateByExampleSelective")
    int updateByExampleSelective(@Param("record") HighTyAgent record, @Param("example") HighTyAgentExample example);

    @UpdateProvider(type=HighTyAgentSqlProvider.class, method="updateByExample")
    int updateByExample(@Param("record") HighTyAgent record, @Param("example") HighTyAgentExample example);

    @UpdateProvider(type=HighTyAgentSqlProvider.class, method="updateByPrimaryKeySelective")
    int updateByPrimaryKeySelective(HighTyAgent record);

    @Update({
        "update high_ty_agent",
        "set org_id = #{orgId,jdbcType=BIGINT},",
          "agent_key = #{agentKey,jdbcType=VARCHAR},",
          "agent_name = #{agentName,jdbcType=VARCHAR},",
          "agent_address = #{agentAddress,jdbcType=VARCHAR},",
          "agent_user = #{agentUser,jdbcType=VARCHAR},",
          "agent_phone = #{agentPhone,jdbcType=VARCHAR},",
          "`status` = #{status,jdbcType=INTEGER},",
          "create_time = #{createTime,jdbcType=TIMESTAMP},",
          "update_time = #{updateTime,jdbcType=TIMESTAMP},",
          "ext_1 = #{ext1,jdbcType=VARCHAR},",
          "ext_2 = #{ext2,jdbcType=VARCHAR},",
          "ext_3 = #{ext3,jdbcType=VARCHAR}",
        "where id = #{id,jdbcType=BIGINT}"
    })
    int updateByPrimaryKey(HighTyAgent record);
}